# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import json
import warnings
import pulumi
import pulumi.runtime
from typing import Union
from . import utilities, tables

class ProjectUser(pulumi.CustomResource):
    accepted: pulumi.Output[bool]
    """
    Whether the user has accepted project membership or not
    """
    email: pulumi.Output[str]
    """
    Email address of the user
    """
    member_type: pulumi.Output[str]
    """
    Project membership type. One of: admin, developer, operator
    """
    project: pulumi.Output[str]
    """
    The project the user belongs to
    """
    def __init__(__self__, resource_name, opts=None, email=None, member_type=None, project=None, __props__=None, __name__=None, __opts__=None):
        """
        ## Example Usage



        ```python
        import pulumi
        import pulumi_aiven as aiven

        mytestuser = aiven.ProjectUser("mytestuser",
            email="john.doe@example.com",
            member_type="admin",
            project=aiven_project["myproject"]["project"])
        ```


        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] email: Email address of the user
        :param pulumi.Input[str] member_type: Project membership type. One of: admin, developer, operator
        :param pulumi.Input[str] project: The project the user belongs to
        """
        if __name__ is not None:
            warnings.warn("explicit use of __name__ is deprecated", DeprecationWarning)
            resource_name = __name__
        if __opts__ is not None:
            warnings.warn("explicit use of __opts__ is deprecated, use 'opts' instead", DeprecationWarning)
            opts = __opts__
        if opts is None:
            opts = pulumi.ResourceOptions()
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.version is None:
            opts.version = utilities.get_version()
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = dict()

            if email is None:
                raise TypeError("Missing required property 'email'")
            __props__['email'] = email
            if member_type is None:
                raise TypeError("Missing required property 'member_type'")
            __props__['member_type'] = member_type
            if project is None:
                raise TypeError("Missing required property 'project'")
            __props__['project'] = project
            __props__['accepted'] = None
        super(ProjectUser, __self__).__init__(
            'aiven:index/projectUser:ProjectUser',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name, id, opts=None, accepted=None, email=None, member_type=None, project=None):
        """
        Get an existing ProjectUser resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param str id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[bool] accepted: Whether the user has accepted project membership or not
        :param pulumi.Input[str] email: Email address of the user
        :param pulumi.Input[str] member_type: Project membership type. One of: admin, developer, operator
        :param pulumi.Input[str] project: The project the user belongs to
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = dict()

        __props__["accepted"] = accepted
        __props__["email"] = email
        __props__["member_type"] = member_type
        __props__["project"] = project
        return ProjectUser(resource_name, opts=opts, __props__=__props__)
    def translate_output_property(self, prop):
        return tables._CAMEL_TO_SNAKE_CASE_TABLE.get(prop) or prop

    def translate_input_property(self, prop):
        return tables._SNAKE_TO_CAMEL_CASE_TABLE.get(prop) or prop

